#
# type: feature
# api: streamtuner2
# title: global keyboard shortcut
# description: allows switching radios in bookmarks list via key press
# version: 0.1
# depends: python-keybinder
#
#
# Binds a key to global desktop (F13 = left windows key). On keypress
# it switches the currently playing radio station to another one in
# bookmarks list.
#
# Valid key names are for example F9, <Ctrl>G, <Alt>R, <Super>N
#



import keybinder
from config import conf
import action
import random



# register a key
class global_key(object):

    module = "global_key"
    title = "keyboard shortcut"
    version = 0.1
    
    config = [
        dict(name="switch_key", type="text", value="XF86forward", description="global key for switching radio"),
        dict(name="switch_channel", type="text", value="bookmarks:favourite", description="station list to alternatie in"),
        dict(name="switch_random", type="boolean", value=0, description="pick random channel, instead of next"),
    ]
    last = 0


    # register
    def __init__(self, parent):
        self.parent = parent
        try:
            keybinder.bind(conf.switch_key, self.switch, ())
        except:
            print "Key could not be registered"
    
        
    # key event
    def switch(self, *any):

        # bookmarks, favourite
        channel, cat = conf.switch_channel.split(":")

        # get list
        streams = self.parent.channels[channel].streams[cat]

        # pick next
        self.last = self.last + 1
        if self.last >= len(streams):
            self.last = 0
        i = self.last
        
        # or just random
        #i = random.randint(0, len(streams)-1)
            
        # play
        action.action.play(streams[i]["url"], streams[i]["format"])


        